// Author: Torsten.Leitner@email.de
// (c) 2006/2007



#include "InAndOut.h"

using namespace std;

int SaveXt(Complex *xt,	int Ntw, double Omegamax , double omega0 ,  char *stdfilename,int filenr)
{
	int jt;

     // class tArrayComplex2D_rt  	A    	 (Nr,Rmax,Ntw,Omegamax);
	class tArrayComplex2D_rt  xw (2,1,Ntw,Omegamax);
	
	for(jt=0;jt<Ntw;jt++) {
		xw.data[1][jt] = Complex(2*xt[jt].real(), 0 ); // 2*Realteil kopieren ...
	}
	
	xw.fft();
		
	ofstream out;
	char filename[120]; sprintf(filename,"%s_%i.xtw.dat",stdfilename,filenr);
	out.open(filename, ios::out|ios::trunc);
//   	cout << "Writing meshdata to \"" << meshname <<"\" ..."<<endl;
   	out << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
   	out << "# Try e.g. :  gnuplot> plot \""<< filename <<"\" u 1:3 w l \n" << endl;
 	out << "# -1- xw->time[jt] -2- xw->omega[jt]in[eV] -3- xw->omega[jt]/omega0 -4- 2*xt[jt].real() -5- abs(xw1) -6- abs(xw2)"<< endl; 
	out << "# xw1 : Complex xt in fft  ---   xw2 : 2*real(xt) in fft "<< endl;
	
   	for (jt=0;jt<Ntw; jt++ ) {
 			out << xw.time[jt] <<" "<< xw.omega[jt] <<" "<< xw.omega[jt]/(omega0*omega_SItoAU) <<" "
			    << 2*xt[jt].real() <<" "<< abs(xw.data[1][jt])  << endl; 
   	}   
   	out << endl; // empty line after every t/w-slice for better data handling in gnuplot
   	out.close();
   	
   	cout << "\n Data saved to: " << filename << endl;
	
	return 0;
}


// ********************************************************************************************** //

int SaveOneLineOnly(class tArrayComplex2D_rt *H, int ir, char *stdfilename, double omega0 , int filenr)
{
	int jt;
	int Ntw = H->Ntw;
//	int Nr  = H->Nr;
//	double dr  = H->dr;
//	double Rmax= H->rmax;
//	double Omegamax = H->wmax;
	
	ofstream out;
	char filename[120]; sprintf(filename,"%s_%i.1l.dat",stdfilename,filenr);
	out.open(filename, ios::out|ios::trunc);
   	out << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
   	out << "# Try:  gnuplot> plot \""<< filename <<"\" w l \n" << endl;
   	
   	for (jt=0;jt<Ntw; jt++ ) {
 			out << H->omega[jt]/omega0 <<" "<< H->data[ir][jt] << endl; 
   	}   
   	out << endl; // empty line after every t/w-slice for better data handling in gnuplot
   	out.close();
   	
   	cout << "\n Data saved to: " << filename << endl;
	
	return 0;
}


// ********************************************************************************************** //

int SaveHarmonicSpectrum_spatiallyIntegrated(class tArrayComplex2D_rt *H,
				  		 					 char *stdfilename, double omega0 , int filenr)
{
	int jt,ir;
	int Ntw = H->Ntw;
	int Nr  = H->Nr;
	double dr  = H->dr*meter_AUtoSI;
//	double Rmax= H->rmax;
//	double Omegamax = H->wmax;
	
	double spec[Ntw];
	
	for(jt=0;jt<Ntw;jt++) {
		spec[jt] =  0;
		for(ir=1;ir<Nr;ir++ ) {
			// I_int = \int_0^rmax {|E|^2  r} 2 pi dr
			spec[jt] += H->intensity(ir,jt) * H->radiusSI(ir);
		}
		spec[jt] *= 2*PI*dr;
	}
	
	ofstream out;
	char filename[120]; sprintf(filename,"%s_%i.int.dat",stdfilename,filenr);
	out.open(filename, ios::out|ios::trunc);
//   	cout << "Writing meshdata to \"" << meshname <<"\" ..."<<endl;
   	out << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
   	out << "# Try:  gnuplot> plot \""<< filename <<"\" w l \n" << endl;
   	
   	for (jt=0;jt<int(0.5*Ntw); jt++ ) {
 			out << H->omegaSI(jt)/omega0 <<" "<< spec[jt] << endl; 
   	}   
   	out << endl; // empty line after every t/w-slice for better data handling in gnuplot
   	out.close();
   	
   	cout << "\n Data saved to: " << filename << endl;
	
	return 0;
}


// ********************************************************************************************** //
int write_twolines( class tArrayComplex2D_rt *A,class tArrayComplex2D_rt *B,int ir, 
				  		 int jtmin, int jtmax, int djt,
				  		 char *stdmeshname)
{
	ofstream meshout;
	char meshname[120];
	sprintf(meshname, "%s.twolines.dat", stdmeshname);
	meshout.open(meshname, ios::out|ios::trunc);
//   	cout << "Writing meshdata to \"" << meshname <<"\" ..."<<endl;
//   	meshout << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
  // 	meshout << "# Try:  gnuplot> plot \""<< meshname <<"\" w l \n" << endl;
   //	meshout << "# Radius : "<< A->radius[ir] << endl;
    int jt;
   	for (jt=jtmin;jt<jtmax; jt+=djt) {
 			meshout << jt <<" "<< A->real(ir,jt) <<" "<< B->real(ir,jt) <<" "<< endl; 
   	}   
 //  	meshout << endl; // empty line after every t/w-slice for better data handling in gnuplot
   	meshout.close();
return 0;
}
// ******************************************** //



// ********************************************************************************************** //
int write_linedat_omega( class tArrayComplex2D_rt *E,int ir, 
				  		 int jtmin, int jtmax, int djt,
				  		 char *stdname, double omega0)
{
	ofstream out;
	char name[120];
	sprintf(name, "%s.line.dat", stdname);
	out.open(name, ios::out|ios::trunc);
//   	cout << "Writing meshdata to \"" << meshname <<"\" ..."<<endl;
   	out << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
   	out << "# Try:  gnuplot> plot \""<< name <<"\" w l \n" << endl;
   	out << "# Radius : "<< E->radius[ir] << endl;
    int jt;
   	for (jt=jtmin;jt<jtmax; jt+=djt) {
 			out << E->omegaSI(jt)/omega0 <<" "<< E->intensity(ir,jt) <<" "<< E->real(ir,jt) <<" "<< E->imag(ir,jt) << endl; 
   	}   
   	out << endl; // empty line after every t/w-slice for better data handling in gnuplot
   	out.close();
   	
   	cout << "\n Data saved to: " << name << endl;
   	
return 0;
}
// ******************************************** //

// ********************************************************************************************** //
int write_linedat( class tArrayComplex2D_rt *E,int ir, 
				  		int jtmin, int jtmax, int djt,
				  		char *stdmeshname)
{
	ofstream meshout;
	char meshname[120];
	sprintf(meshname, "%s.line.dat", stdmeshname);
	meshout.open(meshname, ios::out|ios::trunc);
//   	cout << "Writing meshdata to \"" << meshname <<"\" ..."<<endl;
   	meshout << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
   	meshout << "# Try:  gnuplot> plot \""<< meshname <<"\" w l \n" << endl;
   	meshout << "# Radius : "<< E->radius[ir] << endl;
    int jt;
   	for (jt=jtmin;jt<jtmax; jt+=djt) {
 			meshout << jt <<" "<< E->intensity(ir,jt) <<" "<< E->real(ir,jt) <<" "<< E->imag(ir,jt) << endl; 
   	}   
   	meshout << endl; // empty line after every t/w-slice for better data handling in gnuplot
   	meshout.close();
return 0;
}
// ******************************************** //

// ********************************************************************************************** //
int write_linedat( class tArrayComplex2D_rt *E,int ir, 
				  		int jtmin, int jtmax, int djt,
				  		char *stdmeshname, int filenr   )
{
	ofstream meshout;
	char meshname[120];
	sprintf(meshname, "%s_%i.line.dat", stdmeshname, filenr);
	meshout.open(meshname, ios::out|ios::trunc);
//   	cout << "Writing meshdata to \"" << meshname <<"\" ..."<<endl;
   	meshout << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
   	meshout << "# Try:  gnuplot> plot \""<< meshname <<"\" w l \n" << endl;
   	meshout << "# Radius : "<< E->radius[ir] << endl;
    int jt;
   	for (jt=jtmin;jt<jtmax; jt+=djt) {
 			meshout << jt <<" "<< E->intensity(ir,jt) <<" "<< E->real(ir,jt) <<" "<< E->imag(ir,jt) <<" "<< endl; 
   	}   
   	meshout << endl; // empty line after every t/w-slice for better data handling in gnuplot
   	meshout.close();
return 0;
}
// ******************************************** //

// ********************************************************************************************** //
int write_time_2d( class tArrayComplex2D_rt *E, 
				  		int irmin, int irmax, int dir, 
				  		int jtmin, int jtmax, int djt,
				  		char *stdmeshname, int filenr   )
{
	ofstream meshout;
	char meshname[120];
	sprintf(meshname, "%s_%i.t.dat", stdmeshname, filenr);
	meshout.open(meshname, ios::out|ios::trunc);
//   	cout << "Writing meshdata to \"" << meshname <<"\" ..."<<endl;
   	meshout << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
   	meshout << "# Try:  gnuplot> splot \""<< meshname <<"\" w l \n" << endl;
    int ir,jt;
   	for (ir=irmin;ir<irmax;ir+=dir) { 
   		for (jt=jtmin;jt<jtmax; jt+=djt) {
 			meshout << E->radiusSI(ir) <<" "
 					<< E->timeSI(jt)   <<" "
 					<< E->intensity(ir,jt) <<" "
 					<< E->realSI(ir,jt) <<" "
 					<< E->imagSI(ir,jt) <<" "
 					<< endl; 
   		}   meshout << endl; // empty line after every t/w-slice for better data handling in gnuplot
   	}
   	meshout.close();
return 0;
}
// ******************************************** //

int write_omega_2d(class tArrayComplex2D_rt *E, 
				  		int irmin, int irmax, int dir, 
				  		int jtmin, int jtmax, int djt,
				  		char *stdmeshname, int filenr   )
{

	if (jtmax>int(0.5*E->Ntw)) {jtmax=int(0.5*E->Ntw);}	
	ofstream meshout;
	char meshname[120];
	sprintf(meshname, "%s_%i.w.dat", stdmeshname, filenr);
	meshout.open(meshname, ios::out|ios::trunc);
//   	cout << "Writing meshdata to \"" << meshname <<"\" ..."<<endl;
   	meshout << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
   	meshout << "# Try:  gnuplot> splot \""<< meshname <<"\" w l \n" << endl;
    int ir,jt;
   	for (ir=irmin;ir<irmax;ir+=dir) { 
   		for (jt=jtmin;jt<jtmax; jt+=djt) {
 			meshout << E->radiusSI(ir) <<" "
 					<< E->omegaSI(jt)  <<" "
 					<< E->intensity(ir,jt) <<" "
 					<< E->realSI(ir,jt) <<" "
 					<< E->imagSI(ir,jt) <<" "
 					<< endl; 
   		}   meshout << endl; // empty line after every t/w-slice for better data handling in gnuplot
   	}
   	meshout.close();
return 0;
}
// ******************************************** //

// ******************************************** //

int write_omegaOverOmega0_2d(class tArrayComplex2D_rt *E, double omega0 ,
				  		int irmin, int irmax, int dir, 
				  		int jtmin, int jtmax, int djt,
				  		char *stdmeshname, int filenr   )
{
	if (jtmax>int(0.5*E->Ntw)) {jtmax=int(0.5*E->Ntw);}
	ofstream meshout;
	char meshname[120];
	sprintf(meshname, "%s_%i.w0.dat", stdmeshname, filenr);
	meshout.open(meshname, ios::out|ios::trunc);
//   	cout << "Writing meshdata to \"" << meshname <<"\" ..."<<endl;
   	meshout << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
   	meshout << "# Try:  gnuplot> splot \""<< meshname <<"\" w l \n" << endl;
    int ir,jt;
   	for (ir=irmin;ir<irmax;ir+=dir) { 
   		for (jt=jtmin;jt<jtmax; jt+=djt) {
 			meshout << E->radiusSI(ir) <<" "
 					<< E->omegaSI(jt)/omega0  <<" "
 					<< E->intensity(ir,jt) <<" "
 					<< E->realSI(ir,jt) <<" "
 					<< E->imagSI(ir,jt) <<" "
 					<< endl;  
   		}   meshout << endl; // empty line after every t/w-slice for better data handling in gnuplot
   	}
   	meshout.close();
return 0;
}
// ******************************************** //


// ********************************************************************************************** //
int write_2d(class tArrayComplex2D_rt *E, double *radius, double *wORt, 
				  int irmin, int irmax, int dir, int jtmin, int jtmax, int djt,
				  char *stdmeshname, int filenr  )
{
	ofstream meshout;
	char meshname[120];
	sprintf(meshname, "%s_%i.mesh.dat", stdmeshname, filenr);
	meshout.open(meshname, ios::out|ios::trunc);
//   	cout << "Writing meshdata to \"" << meshname <<"\" ..."<<endl;
   	meshout << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
   	meshout << "# Try:  gnuplot> splot \""<< meshname <<"\" w l \n" << endl;
    int ir,jt;
   	for (ir=irmin;ir<irmax;ir+=dir) { 
   		for (jt=jtmin;jt<jtmax; jt+=djt) {
 			meshout << E->radius[ir] <<" "
 					<< wORt[jt]      <<" "
 					<< E->intensity(ir,jt) <<" "
 					<< E->real(ir,jt) <<" "
 					<< E->imag(ir,jt) <<" "
 					<< endl; 
   		}   meshout << endl; // empty line after every t/w-slice for better data handling in gnuplot
   	}
   	meshout.close();
return 0;
}
// ******************************************** //

// ********************************************************************************************** //
int write_meshdat(Complex **E, double *radius, double *wORt, 
				  int irmin, int irmax, int dir, int jtmin, int jtmax, int djt,
				  char *stdmeshname, int filenr  )
{
	ofstream meshout;
	char meshname[120];
	sprintf(meshname, "%s_%i.mesh.dat", stdmeshname, filenr);
	meshout.open(meshname, ios::out|ios::trunc);
//   	cout << "Writing meshdata to \"" << meshname <<"\" ..."<<endl;
   	meshout << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
   	meshout << "# Try:  gnuplot> splot \""<< meshname <<"\" w l \n" << endl;
    int ir,jt;
   	for (ir=irmin;ir<irmax;ir+=dir) { 
   		for (jt=jtmin;jt<jtmax; jt+=djt) {
 			meshout << radius[ir] <<" "<< wORt[jt] <<" "<< abs(E[ir][jt])*abs(E[ir][jt]) <<" "<< endl; 
   		}   meshout << endl; // empty line after every t/w-slice for better data handling in gnuplot
   	}
   	meshout.close();
return 0;
}
// ******************************************** //


// ********************************************************************************************** //
int write_meshdat(double **feld, double *radius, double *wORt, 
				  int irmin, int irmax, int dir, int jtmin, int jtmax, int djt,
				  char *stdmeshname, int filenr  )
{
	ofstream meshout;
	char meshname[120];
	sprintf(meshname, "%s_%i.mesh.dat", stdmeshname, filenr);
	meshout.open(meshname, ios::out|ios::trunc);
//   	cout << "Writing meshdata to \"" << meshname <<"\" ..."<<endl;
   	meshout << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
   	meshout << "# Try:  gnuplot> splot \""<< meshname <<"\" w l \n" << endl;
    int ir,jt;
   	for (ir=irmin;ir<irmax;ir+=dir) { 
   		for (jt=jtmin;jt<jtmax; jt+=djt) {
 			meshout << radius[ir] <<" "<< wORt[jt] <<" "<< feld[ir][jt] <<" "<< endl; 
   		}   meshout << endl; // empty line after every t/w-slice for better data handling in gnuplot
   	}
   	meshout.close();
return 0;
}
// ******************************************** //

