// Author: Torsten.Leitner@email.de
// (c) 2006/2007


#ifndef INANDOUT_H_
#define INANDOUT_H_


#include <stdio.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>
#include <math.h>
#include <complex>
#include <vector>
#include <sstream>

#include "Constants.h"
#include "tArrayComplex2D_rt.h"


using namespace std;

int SaveXt(Complex *xt,	int Ntw, double Omegamax , double omega0 ,  char *stdfilename,int filenr);

int SaveOneLineOnly(class tArrayComplex2D_rt *H, int ir, char *stdfilename, double omega0 , int filenr);

int SaveHarmonicSpectrum_spatiallyIntegrated(class tArrayComplex2D_rt *H, char *meshname, double omega0, int filenr );
				  		 					 
				  		 					 
int write_twolines( class tArrayComplex2D_rt *A,class tArrayComplex2D_rt *B,int ir, 
				  		 int jtmin, int jtmax, int djt,
				  		 char *stdmeshname);

int write_linedat_omega( class tArrayComplex2D_rt *E,int ir, 
				  		 int jtmin, int jtmax, int djt,
				  		 char *stdmeshname, double omega0);

int write_linedat( class tArrayComplex2D_rt *E,int ir, 
				  		int jtmin, int jtmax, int djt,
				  		char *stdmeshname);

int write_linedat( class tArrayComplex2D_rt *E,int ir, 
				  		int jtmin, int jtmax, int djt,
				  		char *stdmeshname, int filenr   );

int write_time_2d( class tArrayComplex2D_rt *E, 
				  		int irmin, int irmax, int dir, 
				  		int jtmin, int jtmax, int djt,
				  		char *stdmeshname, int filenr   );

int write_omega_2d(class tArrayComplex2D_rt *E, 
				  		int irmin, int irmax, int dir, 
				  		int jtmin, int jtmax, int djt,
				  		char *stdmeshname, int filenr   );
				  		
int write_omegaOverOmega0_2d(class tArrayComplex2D_rt *E, double omega0 ,
				  		int irmin, int irmax, int dir, 
				  		int jtmin, int jtmax, int djt,
				  		char *stdmeshname, int filenr   );				  	

int write_2d(class tArrayComplex2D_rt *E, double *radius, double *wORt, 
				  int irmin, int irmax, int dir, int jtmin, int jtmax, int djt,
				  char *stdmeshname, int filenr  );

int write_2d(Complex **E, double *radius, double *wORt, 
				  int irmin, int irmax, int dir, int jtmin, int jtmax, int djt,
				  char *stdmeshname, int filenr  );
				  
int write_2d(double **E, double *radius, double *wORt, 
				  int irmin, int irmax, int dir, int jtmin, int jtmax, int djt,
				  char *stdmeshname, int filenr  );

#endif /*INANDOUT_H_*/



