// Author: Torsten.Leitner@email.de
// (c) 2006/2007


#include "NonLinearPolarisation.h"

NonLinearPolarisation::NonLinearPolarisation()
{
	IsInitialized = 0;
}

NonLinearPolarisation::~NonLinearPolarisation()
{
	if (IsInitialized == 1) {
		delete VectorPotential;
		delete IntegralA;
		delete IntegralA2;
	}
}

int NonLinearPolarisation::Init(class tArrayComplex2D_rt *laserPtr		, 
								class tArrayComplex2D_rt *harmonixPtr	,
								struct InputParameter *in				)
{
	Laser   = laserPtr;
	Harmonix= harmonixPtr;
	
	Nr  	= Laser->Nr;
	Ntw1 	= Laser->Ntw;
	Ntwh 	= Harmonix->Ntw;
	
	VectorPotential  = new Complex* [Nr];	
		for (ir=0;ir<Nr;ir++) 	{  VectorPotential[ir] = new Complex [Ntw1]; }
	IntegralA        = new Complex* [Nr];	
		for (ir=0;ir<Nr;ir++) 	{  IntegralA[ir]       = new Complex [Ntw1]; }
	IntegralA2       = new Complex* [Nr];	
		for (ir=0;ir<Nr;ir++) 	{  IntegralA2[ir]      = new Complex [Ntw1]; }

		
	IsInitialized = 1;	
	return 0;
}  

/*
int NonLinearPolarisation::Calc()
{
	SuplyVecPot_etal();
	CalcDipoleMoment();
	
	return 0;
}  
// */

// *****************************************************************************
int NonLinearPolarisation::SupplyInterpolationPoints()
{ // Simpson Integration Method
	
//	 ofstream File("vectest.dat", ios::out|ios::trunc);

	double t,dt;
	
	dt = Laser->dt;
	t  = Laser->tmin;
	
	for (int ir=0;ir<Nr;ir++) {
		
		jt = 0;
		t = Laser->tmin;
		VectorPotential	[ir][jt] =	0;
		IntegralA		[ir][jt] =	0;	
		IntegralA2		[ir][jt] =	0;
	    

///  *************************************************************************************
///  Hier wird noch von analytisch bekanntem Laser ausgegangen ...
///   Deswegen gibts hier noch Zwischenschritte (dt/4) ...  
///  -> Integral kann nicht genauer werden als Ausgangsfeld 
///    => Naive StreifenMethode oder TrapezIntegration reicht vollkommen aus ...
///  *************************************************************************************


//     	for (jt=1;jt<Ntw1;jt++) {
//			t+=dt;
//  			tmp1 = VectorPotential[ir][jt-1] +    (0.25*dt /3 ) * 			// tmp1 = A(t-0.5*dt)
//  								( 	Laser->data[ir][jt](t-0.5*dt)  
//							      + 4 * Laser->data[ir][jt](t-0.75*dt)  
//							      +     Laser->data[ir][jt](t-dt) 			) ;
//  
//	  		VectorPotential[ir][jt] = tmp1 + (0.25*dt /3 ) * 						
//  								( 		Laser->data[ir][jt](t)  			
//							      + 4 * Laser->data[ir][jt](t-0.25*dt)  
//							      +     Laser->data[ir][jt](t-0.5*dt) 			) ;
//						      
//		
//		
//// Vector Potentials calculated ... go for the Integrals ...
//						      
//			IntegralA[ir][jt] = IntegralA[ir][jt-1] + (0.5*dt /3 ) * 
//								(		VectorPotential[ir][jt]					// A(t)
//								  + 4 * tmp1   								// A(t-0.5*dt)
//								  +		VectorPotential[ir][jt-1]   		) ;		// A(t-dt)
//							  
//			IntegralA2[ir][jt]= IntegralA2[ir][jt-1] + (0.5*dt /3 ) * 
//								(		VectorPotential[ir][jt]*VectorPotential[ir][jt]						// A^2(t)
//								  + 4 * tmp1*tmp1													// A^2(t-0.5*dt)
//								  +		VectorPotential[ir][jt-1]*VectorPotential[ir][jt-1]   		) ;		// A^2(t-ddt)
//		} // jt-integration-loop
	} // ir-loop

	return 0; 
}
// *****************************************************************************



