// Author: Torsten.Leitner@email.de
// (c) 2006/2007


#ifndef NONLINEARPOLARISATION_H_
#define NONLINEARPOLARISATION_H_



#include <stdio.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <math.h>

#include <complex>
#include <vector>
#include <gsl/gsl_math.h>
#include <gsl/gsl_sf_gamma.h>

#include "tArrayComplex2D_rt.h"

#include "Constants.h"
#include "options.h"
#include "logbuch.h"



class NonLinearPolarisation
{
public:
// constructor
	NonLinearPolarisation();
// destructor	
	virtual ~NonLinearPolarisation();
// funcs	
	int Init(class tArrayComplex2D_rt *laserPtr		, 
		 	 class tArrayComplex2D_rt *HarmonixPtr	,
			 struct InputParameter *in				);
			 
			 
// variables
	int ir,jt,Nr,Ntw1,Ntwh;
	
private:
// variables	
	bool IsInitialized;
	Complex  **VectorPotential, **IntegralA, **IntegralA2 ;
	class tArrayComplex2D_rt *Laser, *Harmonix;
	
// funcs	
	int SupplyInterpolationPoints();


};

#endif /*NONLINEARPOLARISATION_H_*/
