// Author: Torsten.Leitner@email.de
// (c) 2006/2007


#include "threedee_tests.h"

using namespace std;

// Author: Torsten.Leitner@email.de
// (c) 2006/2007



// *********************************************************************************************************************
// *********************************************************************************************************************
// *********************************************************************************************************************
// *********************************************************************************************************************
// *********************************************************************************************************************
// *********************************************************************************************************************
int the_threedee_program(struct InputParameter inpar)
{
char text[256];
//inpar.outfile=string("/home/goofy/data/rhyno/test3D");

/*   //from GOLUM ... artificial but working properly ...
inpar.Nr    	= 30;
inpar.dr       	= 1e-5;
inpar.waist0   	= (inpar.Nr/10)*inpar.dr;
inpar.lifetime  = 7e-17;
inpar.lam     	= inpar.dr*1e-3;
inpar.omega0    = 2*PI*CLIGHT/inpar.lam;
inpar.dz        = inpar.dr*1e-5;
inpar.Ntw     	=  128;  //2**19=524288 // 2**18=262144 // 2**17=131072 // 2**16=65536 // 2**15=32768
		   			     //2**14= 16384 // 2**13=  8192 // 2**12=  4096 // 2**11= 2048 // 2**10= 1024
//*/////

///*   //mine
//inpar.Nr    	=  300;									// in StdParams
//inpar.lam     	=  740e-9;							// in StdParams
//inpar.dr       	=  1e3 * inpar.lam;					// in StdParams	
//inpar.dr		=  inpar.waist0 * 10 / inpar.Nr ;		// in StdParams
//inpar.waist0   	=  (inpar.Nr/10)*inpar.dr;			// in StdParams

//inpar.lifetime  = 15e-15;
//inpar.omega0    =  2*PI*CLIGHT/inpar.lam;
//inpar.dz        =  1e2 * inpar.lam;					// in StdParams
//inpar.dz        =  1e1 * inpar.dr;						// in StdParams
//inpar.Ntw1     	=  inpar.Ntw;  //2**19=524288//2**18=262144//2**17=131072//2**16=65536//2**15=32768
			 			 //2**14= 16384//2**13=  8192//2**12=  4096//2**11= 2048//2**10= 1024
//*/////

// muss noch in SetStandardInputParameters(...);
inpar.w1max	= 2.5 * inpar.omega0; /// 2*omega gibt schoene darstellung aber zuwenig fuer Y(w), 
								  //  ...  da das Maximum bei 2*omega0 liegt ... ab 2.5*omega0 funzts ...
inpar.rmax	= (inpar.Nr-1)*inpar.dr;


/*  // original RHYNO parameters
int    Nr 	= 30;
double E0       =1.0;
double xlam     = 800e-9; 		//[m]
double omega0   = 2*PI*CLIGHT/xlam;  	//[rad/s]
double  dr      = xlam*1e3;	//[m]
double  dz      =  dr*1e-5;	//[m]
double  waist0  = (Nr-1)*dr / 1;//[m]
double  zfocus  = 0;// *dr;  	// relative to capillary
//*/

//inpar.lifetime = 10e-15;
//int 	nruns  	  = inpar.nruns;
//int 	nsteps 	  = inpar.nsteps;

int	    Ntw	  	  = inpar.Ntw;

//inpar.Nr = 2 ;

double  dz	      = inpar.dz; dz= inpar.dz;
int	    Nr  	  = inpar.Nr;
double  Omegamax 	  = inpar.w1max;
double  Rmax      = inpar.rmax;

inpar.Ip    =   IP_NEON; // [eV] 
inpar.ZAtom =    Z_NEON; // 1

double Ip; Ip	  = inpar.Ip;
int ZAtom; ZAtom  = inpar.ZAtom;


/*//////
 Bedingungen an Punktzahl und dt:
Def.:  L := T / tau ;  --> Anz. an Lebenszeiten, die min. ins Zeitfenster passen sollen. ( L > 5 ist wuenschenswert)

a) Um Q.te Harmonische noch Darzustellen:     	dt = PI/(Q*w0)

b) Um Puls im t-Raum genuegend darzustellen:  	T >= L*tau;

				T = (N-1)*dt >= L*tau  -->	 	N >= 1 + L*tau/dt = 1 + L*Q*tau*w0/PI

>>>>>>>>  Werte Bedingung a) aus und passe dann gegebenenfalls N gemaess Bedingung b) an.	
/*//////

double Q = 2;  // Maximum sampled frequency in units of the fundamental Laser's frequency
double L = 3 ;  // Minimum size of the Time-Window in units of the lifetime of the Laser.

double dt = PI / (Q*inpar.omega0); // = 2*PI / N*dw = PI / wNyq ;


// Check the Number of Points in time wether it's even and 
//		it's big enough to represent the whole Laser-Pulse ( ie: T > 8*tau )
int nn = int(1+L*inpar.lifetime/dt); // nn = min. Nr. of time points, related to tau 
if(  Ntw  <=  nn ) { Ntw  =  nn+1; sprintf(text,"Increased  number of points in time --> Ntw = %i",Ntw);    log::both(text); }   // Lieber 1 zuviel, als zuwenig ...
if( Ntw%2 !=   0 ) { Ntw +=  1   ; sprintf(text,"\"Evenized\" number of points in time --> Ntw = %i",Ntw); log::both(text); }
//  Even number of time-points needed for the tArrayClass ...
Omegamax = Q * inpar.omega0; /// 2*omega0 gibt schoene darstellung aber zuwenig fuer Y(w), 
								  //  ...  da das Maximum bei 2*omega0 liegt ... ab 2.5*omega0 funzts ...
inpar.w1max	=  Omegamax;
inpar.whmax	=  Omegamax;

inpar.omega0 =0;

int   	filenr=100;
int		filenrLaser=filenr;
//int		filenrHarm =filenr;
//char *stdname="/home/leitner/data/rhyno/rhynotest";
char stdmeshname[80];
sprintf(stdmeshname, "%s_%ifs", inpar.outfile.c_str() , int(0.1 + inpar.lifetime*1e15) ); 
//ofstream meshout; 

class tArrayComplex3D_xyt 	Laser    (Nr,Rmax,Ntw,Omegamax);
class tArrayComplex3D_xyt 	Src1     (Nr,Rmax,Ntw,Omegamax);
	
//class tArrayComplex3D_xyt    Harm    (Nr,Rmax,Ntw,Omegamax);
//class tArrayComplex3D_xyt    P 	 	 (Nr,Rmax,Ntw,Omegamax);
////class tArrayComplex3D_xyt    SrcH 	 (Nr,Rmax,Ntw,Omegamax);		
//
//class tArrayComplex3D_xyt  	A    	 (Nr,Rmax,Ntw,Omegamax);
//class tArrayComplex3D_xyt  	IntA  	 (Nr,Rmax,Ntw,Omegamax);
//class tArrayComplex3D_xyt  	IntA2 	 (Nr,Rmax,Ntw,Omegamax);
//
//Complex *xt;  xt = new Complex[Ntw];



//class tArrayComplex3D_xyt 	Harmonics(Nr,Rmax,Ntw,Omegahmax);


// evtl. copy-constructor verwenden ... Src1=Laser;
//	--> Gleiche Grid-Parameter trivial gesichert ...	

//double  **ExpIntTir; // expIntegralTunnelIonRate  R(t) = int(exp(-tir(t))
// ExpIntTir = new double* [(Nr*Nr)];	        for (int i=0;i<(Nr*Nr);i++) { ExpIntTir[i] = new double [Ntw]; }

//
//int dirout   = 1;
//int irminout = 0;
//int irmaxout = Nr-1 -int(Nr/4) ; // 3/4 von r werden ausgegeben
//int djtout   = 1;
//////int jtminout  = int(Ntw/8);int jtmaxout  = Ntw - jtminout;
//////int jtminout  = int(Ntw/4); int jtmaxout  = Ntw - jtminout;
//int jtminout  = 0; int jtmaxout  = Ntw - 1;

 //*
log::screen("");
log::screen(LOG_SEPARATOR_STARS);
log::screen("");

sprintf(text,"Output set to \"%s_XXX.xxx.dat\" ",stdmeshname );  										log::both(text);
sprintf(text,"dt %g --- T/tau %g", dt , (Ntw-1)*dt/inpar.lifetime);  									log::both(text);
																										log::both(""); 
sprintf(text,"Rmax   	= %g [m]    	  = %g  * waist0       ",inpar.rmax,inpar.rmax/inpar.waist0 );  log::both(text);
sprintf(text,"zfocus 	= %g [m] | waist0 = %g [m]             ",inpar.zfocus,inpar.waist0 );			log::both(text);
sprintf(text,"w1min/max = (+/-) %g [Hz]   = (+/-) %g  * omega0 ",Laser.wmax,Laser.wmax/inpar.omega0 );	log::both(text);
sprintf(text,"t1min/max = (+/-) %g [s]    = (+/-) %g * lifetime",Laser.tmax,Laser.tmax/inpar.lifetime );log::both(text);
																										log::both("");
sprintf(text,"Atomdensity n0        = %g [1/m3] = %g[1/cm3]",inpar.AtomDensity,1e-6*inpar.AtomDensity );log::both(text);
sprintf(text,"Gas temperature       = %g [Kelvin]                   ",inpar.Temperature );				log::both(text);
sprintf(text,"Gas pressure          = %g [mbar]                     ",inpar.Pressure    );				log::both(text);
sprintf(text,"Max. Intensity        = %g [W/cm2]                    ",inpar.Intensity   );				log::both(text);
sprintf(text,"E0 - Max.Ampl.        = %g [V/m]                      ",inpar.E0          );				log::both(text);
sprintf(text,"Fund. wavelength      = %g [m]            ",inpar.lam);									log::both(text);
sprintf(text,"Fund. frequency   w0  = %g [Hz]           ",inpar.omega0);								log::both(text);
																										log::both("");
sprintf(text,"Pond. Potential   Up  = %g [J]            ",inpar.Up);  									log::both(text);
sprintf(text,"Cut off:         qcut = %g                ",inpar.qcut);								    log::both(text);
																										log::both("");									
sprintf(text,"Propagation Step         dz = %g [m] = %g * lam ",inpar.dz,inpar.dz/inpar.lam);			log::both(text);
sprintf(text,"Radial grid width        dr = %g [m] = %g * lam ",inpar.dr,inpar.dr/inpar.lam);			log::both(text);
sprintf(text,"Number of spatial points           Nr= %i       ",inpar.Nr);                   			log::both(text);
log::both("");
sprintf(text,"Number of points in time          Ntw= %i       ",Ntw);                   				log::both(text);
log::both(LOG_SEPARATOR_STARS);
sprintf(text,"nPics  : % 4i",inpar.nPics); 	log::both(text);
sprintf(text,"nruns  : % 4i",inpar.nruns 		); 	log::both(text);
sprintf(text,"nsteps : % 4i",inpar.nsteps 	); 	log::both(text);
log::both(LOG_SEPARATOR_STARS);
log::both("");
// */
//% ***************************************************************************
//% ***************************************************************************

//double Src1Prefactor  = PREFACTOR_FUNDAMENTAL_SOURCE;//= ECHARGE*ECHARGE/(EPSILONZERO*EMASS*CLIGHT*CLIGHT)=3.5411282e-14[m]
double Src1Prefactor  = ECHARGE*ECHARGE/(EPSILONZERO*EMASS*CLIGHT*CLIGHT);//=3.5411282e-14[m]
	   Src1Prefactor *= inpar.AtomDensity;
//	   Src1Prefactor *= 1e-13;  // willkuerliche Konstante ...
//	   Src1Prefactor *= 0;

// ******************************************************************************************************* //
// ************ Main loop evolve nruns*nsteps; drop data after every run ... ***************************** //
// ******************************************************************************************************* //



double TotalPropagationLength = 0;



/////InitFundamentalLaser_GaussianProfile_tSpace( &Laser,  &inpar );   
//
//// % ***************************************************************************
//int InitFundamentalLaser_GaussianProfile_tSpace(class  tArrayComplex3D_xyt *Laser, 
//												struct InputParameter     *in     )   
//{
////*
//	if ( (Laser.dr==0)|(Laser.dw==0)|(Laser.dt==0) ) { cout << "Laser not correctly initialized ..."<<endl; return 1; }
	cout << " Start init Laser field ..." << endl;
	double rxy;
//	for (int ir=0;ir<Laser.Nxy();ir++) {      //% Calc Laser(t)
	for (int ix=0;ix<Laser.Nr;ix++) {      //% Calc Laser(t)
	  for (int iy=0;iy<Laser.Nr;iy++) {      //% Calc Laser(t)
  		for (int jt=0;jt<Laser.Ntw;jt++) {
  			rxy = sqrt( (Laser.radius[ix]-Laser.x0)*(Laser.radius[ix]-Laser.x0) + (Laser.radius[iy]-Laser.y0)*(Laser.radius[iy]-Laser.y0) ); 
	 		Laser.data[ Laser.index(ix,iy) ][jt]  //= ...
	 				=	  gauss2d_radial(inpar.E0,rxy,inpar.waist0,inpar.zfocus,inpar.lam) 
	 				   *  gauss_tdomain (Laser.time[jt], (2*PI*CLIGHT/inpar.lam),inpar.lifetime) ;
  		}
	  }
	}
//  LASER INITIALIZED ...


// Write Laser(t) and Laser(w)	
	sprintf(text, "%s_Laser",  stdmeshname ); 
	write_3D_time (&Laser, text, filenrLaser  );
	cout << "Laser.fft();"<< endl;	Laser.fft();
	write_3D_omega(&Laser, text, filenrLaser  );
	filenrLaser++ ;
	cout << "Laser.ifft();"<< endl;	Laser.ifft();



cout << " Start evolve ... " << endl;
cout << " ***************************** " << endl;	
for (int np=1;np<1+inpar.nPics;np++) {
	
	
	for (int nr=1;nr<1+inpar.nruns;nr++) {
		sprintf(text,"Pic  % 3i  Run % 3i ... % 4i steps ...",np,nr,inpar.nsteps);
		log::both( text );		
/*
/// begin Sources
		double IntTir=0; 			

//  Calc exp[-int(tir)] ...   R(t) in der Dipl.Arbeit
			//	tir = TIR_fit_Ne( E );				//	tir = TIR_fit_He( E );
		for (int ir=0;ir<Nr;ir++)	{	
			IntTir = 0;  //  new spatial position  r_i -> IntTir = 0
			ExpIntTir[ir][0] = 1; // IntTir[ir][0] = 0  ->  exp(0) = 1;
			for (int jt=1;jt<Ntw;jt++)	{ //start from 1 ...
				IntTir += Laser.dt * 0.5 * ( TIR_fit_Ne( Laser.real(ir,jt-1) ) + TIR_fit_Ne( Laser.real(ir,jt) ) );     
					// berechnet log(R(t)) = \int_{-infty}^{t} w(t') dt'
				ExpIntTir[ir][jt] = exp( - IntTir  );	         // berechnet     R(t)  = \exp\[ \int_{-infty}^{t} w(t') dt' \]
			}
		}
// ExpIntTir done for all  ir,jt ... and this z

//
//   begin NL-SOURCE
	CalcVecPotAndIntegrals (&Laser, &A, &IntA, &IntA2);	
	
	
	for (int ir=0;ir<Nr;ir++) {		
	
	//CalcDipoleMoment for one ir only ...
	
		if ( TestLaserBigEnoughForDipoleMoment(&Laser, ir) ) 
		{
			CalcDipoleMoment(xt, &Laser, &A, &IntA, &IntA2,  ir , Ntw, Laser.dt, inpar.omega0, Ip);	
	
	//	Kopiere:  P(r,z,t) = (n0-ne(r,z,t))*d_nl(r,z,t) .... P(t)={n0-n0*[1-R(t)]}*{R(t)*x(t)}=n0 * R(t)^2 * 2*Re{x(t)} 
			for (int jt=0;jt<Ntw;jt++){	
				P.data[ir][jt] = Complex(inpar.AtomDensity * ExpIntTir[ir][jt]*ExpIntTir[ir][jt] * 2*xt[jt].real(), 0 );   		   
			}
		}
		else {
			cout << "Laser Intensity to low at  ir = " << ir << endl; 
			for (int jt=0;jt<Ntw;jt++){	
				P.data[ir][jt] = Complex( 0 , 0 );   		   
			}
		}
	}  // end for ir , Nr1
//	end NL-SOURCE::Polarisation

//*/
// ******* Calculate the fundamental source term ... Src1 ************************************************ //
//
// Src1(t) = SquarePlasmaFrequency(t) * E1(t) / c^2
// 		   =  (e^2/epsi0*me)* n0   * { 1-exp(-int_-inf^t[tir(t') dt'])} * E1(t) / c^2  
// 		   = (e^2*n0/epsi0*me*c^2) * { 1 - ExpIntTir[ir][jt] }          * E1[ir][jt] 
//		   =    Src1Prefactor      * { 1 - ExpIntTir[ir][jt] }          * E1[ir][jt];  

    	for (int ir=0;ir<Laser.Nr;ir++) { 
    		for (int jt=0;jt<Laser.Ntw;jt++) {
//    		  Src1.data[ir][jt] =  Laser.data[ir][jt];
//            Src1.data[ir][jt] = Complex(ExpIntTir[ir][jt],0);
//    		  Src1.data[ir][jt] = Src1Prefactor * ( 1 - ExpIntTir[ir][jt] ) * Laser.data[ir][jt];
    		  Src1.data[ir][jt] = Complex(0,0);
//    		  cout << ir <<" "<< jt <<" "<<Src1.data[ir][jt] << endl; 
    		}
    	}
    // cout << " Src1 calculated ..." << endl;
///// ******************************  Src1(w) calculated ... *************************** //    
//



//	Laser.fft();	// E(t)    --> E(w)

//	Src1.fft();     // Src1(t) --> Src1(w)
//	P.fft();		// P(t)    --> P(w)
	// Multiply P(w) to act as NL-Source: SrcH = -mue0 * w^2 * P(w); 
//	for (int ir=0;ir<Nr;ir++){for (int jt=0;jt<Ntw;jt++){  P.data[ir][jt] *= -MUEZERO * P.omega[jt]*P.omega[jt] ; }}
	//
	// EVOLVE everything for nsteps*dz without new calculation of the Sources ...

	evolve3d( inpar.nsteps, dz, &Laser, &Src1);   		    //% Evolve nsteps fundamental ...

//	evolve( inpar.nsteps, dz, &Harm , &P   );   		    //% Evolve nsteps harmonics ...
	TotalPropagationLength += inpar.nsteps * dz ;
	//

//	Laser.ifft();	// E(w) --> E(t)

	// P and Src1 will be overwritten by their new calculations ...   Harm is only needed in w-space ...
//

	} // end nruns


cout << "Propagated to z = "<< TotalPropagationLength << " [m]" << endl;

// Write Laser(t) and Laser(w)	
	sprintf(text, "%s_Laser",  stdmeshname ); 
	write_3D_time (&Laser, text, filenrLaser  );
	cout << "Laser.fft();"<< endl;	Laser.fft();
	write_3D_omega(&Laser, text, filenrLaser  );
	filenrLaser++ ;
	cout << "Laser.ifft();"<< endl;	Laser.ifft();
	
cout << " ***************************** " << endl;


} // end npics
// */

sprintf(text,"\n *** hhg simulation done *** \n" ); 												log::screen(text);
sprintf(text,"I did %i Cranck-Nicholson Propagation steps.",int(TotalPropagationLength / dz) 	); 	log::both(text);
sprintf(text,"-> Total Propagation Length: %10.8g [m]",TotalPropagationLength	); 					log::both(text);
//cout << "\n *** hhg simulation done *** \n" << endl;
//cout << "I did "<< TotalPropagationLength / dz << " Cranck-Nicholson Propagation steps." << endl;
//cout << "-> Total Propagation Length: "<< TotalPropagationLength << " [m] ..." << endl;
return 0;
}
// *********************************************************************************************************************
// *********************************************************************************************************************
// *********************************************************************************************************************
// *********************************************************************************************************************

// *********************************************************************************************************************
// *********************************************************************************************************************
